Package com.io7m.waxmill.machines

# Class WXMDeviceHostBridge

java.lang.Object
com.io7m.waxmill.machines.WXMDeviceHostBridge

All Implemented Interfaces:
  `WXMDeviceType`, `WXMDeviceType.WXMDeviceHostBridgeType`

    public final class WXMDeviceHostBridge
    extends java.lang.Object
    implements WXMDeviceType.WXMDeviceHostBridgeType

Immutable implementation of `WXMDeviceType.WXMDeviceHostBridgeType`.

Use the builder to create immutable instances: `WXMDeviceHostBridge.builder()`.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXMDeviceHostBridge.Builder` | Builds instances of type `WXMDeviceHostBridge`.

  ## Nested classes/interfaces inherited from interface com.io7m.waxmill.machines.WXMDeviceType

  `WXMDeviceType.Kind, WXMDeviceType.WXMDeviceAHCIDiskType, WXMDeviceType.WXMDeviceAHCIOpticalDiskType, WXMDeviceType.WXMDeviceE1000Type, WXMDeviceType.WXMDeviceFramebufferType, WXMDeviceType.WXMDeviceHostBridgeType, WXMDeviceType.WXMDeviceLPCType, WXMDeviceType.WXMDevicePassthruType, WXMDeviceType.WXMDeviceVirtioBlockStorageType, WXMDeviceType.WXMDeviceVirtioNetworkType, WXMDeviceType.WXMLPCTTYNames, WXMDeviceType.WXMSectorSizesType, WXMDeviceType.WXMStorageBackendFileType, WXMDeviceType.WXMStorageBackendType, WXMDeviceType.WXMStorageBackendZFSVolumeType, WXMDeviceType.WXMTTYBackendFileType, WXMDeviceType.WXMTTYBackendNMDMType, WXMDeviceType.WXMTTYBackendStdioType, WXMDeviceType.WXMTTYBackendType`

  ## Nested classes/interfaces inherited from interface com.io7m.waxmill.machines.WXMDeviceType.WXMDeviceHostBridgeType

  `WXMDeviceType.WXMDeviceHostBridgeType.Vendor`

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static WXMDeviceHostBridge.Builder` | `builder()` | Creates a builder for `WXMDeviceHostBridge`.
  `java.lang.String` | `comment()` |
  `static WXMDeviceHostBridge` | `copyOf​(WXMDeviceType.WXMDeviceHostBridgeType instance)` | Creates an immutable copy of a `WXMDeviceType.WXMDeviceHostBridgeType` value.
  `WXMDeviceSlot` | `deviceSlot()` |
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXMDeviceHostBridge` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `deviceSlot`, `vendor`, `comment`.
  `java.lang.String` | `toString()` | Prints the immutable value `WXMDeviceHostBridge` with attribute values.
  `WXMDeviceType.WXMDeviceHostBridgeType.Vendor` | `vendor()` |
  `WXMDeviceHostBridge` | `withComment​(java.lang.String value)` | Copy the current immutable object by setting a value for the `comment` attribute.
  `WXMDeviceHostBridge` | `withDeviceSlot​(WXMDeviceSlot value)` | Copy the current immutable object by setting a value for the `deviceSlot` attribute.
  `WXMDeviceHostBridge` | `withVendor​(WXMDeviceType.WXMDeviceHostBridgeType.Vendor value)` | Copy the current immutable object by setting a value for the `vendor` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.waxmill.machines.WXMDeviceType

  `isConsoleDevice, isStorageDevice`

  ### Methods inherited from interface com.io7m.waxmill.machines.WXMDeviceType.WXMDeviceHostBridgeType

  `externalName, kind`

- ## Method Details

  - ### deviceSlot

    public WXMDeviceSlot deviceSlot()
    Specified by:
      `deviceSlot` in interface `WXMDeviceType`
    Specified by:
      `deviceSlot` in interface `WXMDeviceType.WXMDeviceHostBridgeType`
    Returns:
      The value of the `deviceSlot` attribute

  - ### vendor

    public WXMDeviceType.WXMDeviceHostBridgeType.Vendor vendor()
    Specified by:
      `vendor` in interface `WXMDeviceType.WXMDeviceHostBridgeType`
    Returns:
      The value of the `vendor` attribute

  - ### comment

    public java.lang.String comment()
    Specified by:
      `comment` in interface `WXMDeviceType`
    Specified by:
      `comment` in interface `WXMDeviceType.WXMDeviceHostBridgeType`
    Returns:
      The value of the `comment` attribute

  - ### withDeviceSlot

    public final WXMDeviceHostBridge withDeviceSlot​(WXMDeviceSlot value)
    Copy the current immutable object by setting a value for the `deviceSlot` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for deviceSlot
    Returns:
      A modified copy of the `this` object

  - ### withVendor

    public final WXMDeviceHostBridge withVendor​(WXMDeviceType.WXMDeviceHostBridgeType.Vendor value)
    Copy the current immutable object by setting a value for the `vendor` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for vendor
    Returns:
      A modified copy of the `this` object

  - ### withComment

    public final WXMDeviceHostBridge withComment​(java.lang.String value)
    Copy the current immutable object by setting a value for the `comment` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for comment
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXMDeviceHostBridge` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `deviceSlot`, `vendor`, `comment`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXMDeviceHostBridge` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static WXMDeviceHostBridge copyOf​(WXMDeviceType.WXMDeviceHostBridgeType instance)
    Creates an immutable copy of a `WXMDeviceType.WXMDeviceHostBridgeType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXMDeviceHostBridge instance

  - ### builder

    public static WXMDeviceHostBridge.Builder builder()
    Creates a builder for `WXMDeviceHostBridge`.

         WXMDeviceHostBridge.builder()
            .setDeviceSlot(com.io7m.waxmill.machines.WXMDeviceSlot) // required deviceSlot
            .setVendor(com.io7m.waxmill.machines.WXMDeviceType.WXMDeviceHostBridgeType.Vendor) // required vendor
            .setComment(String) // optional comment
            .build();

    Returns:
      A new WXMDeviceHostBridge builder